﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;
using InDesign;
using LingvoNET;

namespace IndexId
{
    class Program
    {
        private static CyrName cyrName = new CyrName();

        static void Main(string[] args)
        {
            string[] words = { "Адрахиль", "Нуменор", "эпоха" };
            foreach (string item in words)
            {
                Noun noun = Nouns.FindSimilar(item);

                List<string> nounArray = new List<string>();
                nounArray.Add(noun[Case.Accusative, Number.Singular]);
                nounArray.Add(noun[Case.Dative, Number.Singular]);
                nounArray.Add(noun[Case.Genitive, Number.Singular]);
                nounArray.Add(noun[Case.Instrumental, Number.Singular]);
                nounArray.Add(noun[Case.Locative, Number.Singular]);
                nounArray.Add(noun[Case.Nominative, Number.Singular]);

                nounArray.Add(noun[Case.Accusative, Number.Plural]);
                nounArray.Add(noun[Case.Dative, Number.Plural]);
                nounArray.Add(noun[Case.Genitive, Number.Plural]);
                nounArray.Add(noun[Case.Instrumental, Number.Plural]);
                nounArray.Add(noun[Case.Locative, Number.Plural]);
                nounArray.Add(noun[Case.Nominative, Number.Plural]);

                string[] uniqnounArray = nounArray.Distinct().ToArray();

                Console.WriteLine("Склонения");
                foreach (var item1 in uniqnounArray)
                {
                    Console.WriteLine(item1);
                }
                Console.WriteLine("Найдены в документе");

                Application myApp = new InDesign.Application();
                Document myDoc = myApp.ActiveDocument;
                
                if (myDoc.Indexes.Count == 0)
                {
                    myDoc.Indexes.Add();
                }

                Index myIndex = myDoc.Indexes[1];
                Topic myTopic = myIndex.Topics.Add(item);

                FindTextPreference myFindTextPreferences = myApp.FindTextPreferences;
                for (int i = 0; i < uniqnounArray.Length; i++)
                {

                    myFindTextPreferences.FindWhat = uniqnounArray[i];
                    if (myDoc.FindText().Count > 0)
                    {
                        Console.WriteLine(uniqnounArray[i]);

                        myFindTextPreferences.FindWhat = uniqnounArray[i];
                        Objects findText = myDoc.FindText();
                        for (int j = 1; j <= findText.Count; j++)
                        {
                            myTopic.PageReferences.Add(findText[j]);
                        }

                    }
                }
                Console.WriteLine("");
            }

            Console.WriteLine("Готово!");
            Console.ReadLine();

        }
    }
}
